<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class MovimentacaoRepository {
    /** @var EntityManager */
    protected $entityManager;

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function setMovimentacao(
        array $params
    ): void {
        $sql = <<< SQL
            INSERT INTO GPE_MOVIMENTACAO (
                NRMOVIMENTACAO,     NRORG,              NRVINCULOM,
                NRTIPOTRANSFER,     NRTPMOVTRANSFM,     NRMOTIVOTRANSF,
                NRESTRUTURAM,       DTINIMOVIMENT,      DTFIMMOVIMENT,
                DSOBSERVACAO,       DTINCLUSAO,         DTULTATU,
                NRORGINCLUSAO,      CDOPERINCLUSAO,     NRORGULTATU,
                CDOPERULTATU,       NRTIPOESTRUTURA,    DTMOVIMENTRETRO,
                IDATUALIZAACERTO,   NRMOTIVOAFASTA
            )
            VALUES (
                :NRMOVIMENTACAO,    :NRORG,             :NRVINCULOM,
                :NRTIPOTRANSFER,    :NRTPMOVTRANSFM,    :NRMOTIVOTRANSF,
                :NRESTRUTURAM,      :DTINIMOVIMENT,     :DTFIMMOVIMENT,
                :DSOBSERVACAO,      :DTINCLUSAO,        :DTULTATU,
                :NRORGINCLUSAO,     :CDOPERINCLUSAO,    :NRORGULTATU,
                :CDOPERULTATU,      :NRTIPOESTRUTURA,   :DTMOVIMENTRETRO,
                :IDATUALIZAACERTO,  :NRMOTIVOAFASTA
            )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}