<?php

namespace Ems\Services;

use Util\Environment;
use Ems\Repository\HierarquiaRepository;
use Util\NovoCodigo;

class HierarquiaService {
    /** @var Environment */
    protected $environment;

    /** @var HierarquiaRepository */
    protected $hierarquiaRepository;

    public function __construct(
        Environment             $environment,
        HierarquiaRepository    $hierarquiaRepository
    ) {
        $this->environment          = $environment;
        $this->hierarquiaRepository = $hierarquiaRepository;
    }

    public function getTiposHierarquia(): array {
        $nrOrg = (int) $this->environment->getNrOrg();
        $nrOrgPadrao = (int) $this->environment->getNrOrgPadrao();

        $params = [
            'P_NRORG'           => $nrOrg,
            'P_NRORG_PADRAO'    => $nrOrgPadrao,
        ];

        $result = $this->hierarquiaRepository->getTiposHierarquia($params);

        return $result;
    }
}