-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 31/08/2004                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Grava os produtos filhos da ITDESPREBASE         --
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\2855_PEDSTPO.SQL                    --
-- ================================================================== --
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GRAVA_ITDESPREBASE' AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

DROP PROCEDURE GRAVA_ITDESPREBASE
GO

CREATE PROCEDURE GRAVA_ITDESPREBASE
   @P_CDPRECOBASE  VARCHAR(2),
   @P_CDPAIS       VARCHAR(4),
   @P_LISTAESTADO  VARCHAR(2000),
   @P_VRPEMAXDESPR NUMERIC,
   @P_CDPRODINI    VARCHAR(20),
   @P_CDPRODFIN    VARCHAR(20),
   @P_IDTRATADESC  VARCHAR(1)

AS

   DECLARE @V_CTPROD    NUMERIC;
   DECLARE @V_SGESTADO  VARCHAR(2);
   DECLARE @V_CDPRODUTO VARCHAR(10);
BEGIN
   DECLARE C_EST CURSOR FOR
       SELECT SGESTADO
       FROM ESTADO
       WHERE (CDPAIS = @P_CDPAIS)
         AND ((CHARINDEX(SGESTADO, @P_LISTAESTADO) <> 0)OR(@P_LISTAESTADO = 'T'))
       ORDER BY SGESTADO
   OPEN C_EST;
   FETCH NEXT FROM C_EST INTO @V_SGESTADO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      DECLARE C_PROD CURSOR FOR
          SELECT CDPRODUTO
          FROM PRODUTO
          WHERE CDARVPROD BETWEEN @P_CDPRODINI AND @P_CDPRODFIN
            AND CDPRODESTO IS NOT NULL
          ORDER BY CDARVPROD
      OPEN C_PROD;
      FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_CTPROD = COUNT(CDPRODUTO)
         FROM ITDESPREBASE
         WHERE CDPRECOBASE = @P_CDPRECOBASE
           AND CDPAIS      = @P_CDPAIS
           AND SGESTADO    = @V_SGESTADO
           AND CDPRODUTO   = @V_CDPRODUTO;

         IF (@V_CTPROD > 0) BEGIN
            IF (@P_IDTRATADESC = 'S') BEGIN
               UPDATE ITDESPREBASE
               SET VRPEMAXDESPR = @P_VRPEMAXDESPR
               WHERE CDPRECOBASE = @P_CDPRECOBASE
                 AND CDPAIS      = @P_CDPAIS
                 AND SGESTADO    = @V_SGESTADO
                 AND CDPRODUTO   = @V_CDPRODUTO;
            END;
         END
         ELSE BEGIN
            INSERT INTO ITDESPREBASE
               (CDPRECOBASE, CDPAIS, SGESTADO, CDPRODUTO, VRPEMAXDESPR)
            VALUES
               (@P_CDPRECOBASE, @P_CDPAIS, @V_SGESTADO, @V_CDPRODUTO, @P_VRPEMAXDESPR);
         END;
         FETCH NEXT FROM C_PROD INTO @V_CDPRODUTO;
      END;
      CLOSE C_PROD;
      DEALLOCATE C_PROD;

      FETCH NEXT FROM C_EST INTO @V_SGESTADO;
   END;
   CLOSE C_EST;
   DEALLOCATE C_EST;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_ITDESPREBASE','4.09.034';
GO

